#include "SiteList.h"

void SiteList::ClearAll()
{
	try
	{
		std::list<Website> temp;
		char flag;
		
		while (1)
		{
			std::cout << "Are you sure you want to clear all data? (Y)es/(N)o: ";
			std::cin.get(flag);
			std::cin.ignore(1, '\n');	
					
			if (flag == 'Y' || flag == 'y')
			{
				itsList = temp;
				break;
			}
			else if (flag == 'N' || flag == 'n')
				break;
			else if (flag != 'Y' && flag != 'y' && flag != 'N' && flag != 'n' || !flag)
				std::cout << "Please enter the letter Y or N. " << std::endl;
		}
	}
	catch(...)
	{		
		std::cout << "\n\nAn unknown error has occurred." << std::endl;
	}
}



void SiteList::ConvertDateFormat(char *date)
{
	try
	{
		std::string temp;
		
		if (date[0] == '0')
		{
			switch (date[1])
			{
				case '1':
					temp = "January ";
					break;
				case '2':
					temp = "February ";
					break;
				case '3':
					temp = "March ";
					break;
				case '4':
					temp = "April ";
					break;
				case '5':
					temp = "May ";
					break;
				case '6':
					temp = "June ";
					break;
				case '7':
					temp = "July ";
					break;
				case '8':
					temp = "August ";
					break;
				case '9':
					temp = "September ";
					break;
				default:
					return;
			}
		}
		else if (date[0] == '1')
		{
			switch (date[1])
			{
				case '0':
					temp = "October ";
					break;
				case '1':
					temp = "November ";
					break;
				case '2':
					temp = "December ";
					break;
				default:
					return;
			}
		}
		else
			return;

		
		if (date[2] == '/' || date[2] == '.')
		{
			if (date[3] != '0')
				temp += date[3];
			temp += date[4];
			switch (date[4])
			{
				case '1':
					temp += "st, ";
					break;
				case '2':
					temp += "nd, ";
					break;
				case '3':
					temp += "rd, ";
					break;
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
				case '0':
					temp += "th, ";
					break;
				default:
					return;
			}
		}
		else
			return;
		
		if (date[5] == '/' || date[5] == '.')
		{
			int i;
			for (i = 6; date[i] != '\0'; i++)
				;
			if (i == 8)
			{
				if (date[6] < '9')
					temp += "20";
				else if (date[6] == '9')
					temp += "19";
				
				temp += date[6];
				temp += date[7];
			}
			else
				for (int j = 6; date[j] != '\0'; j++)
					temp += date[j];
		}
		else
			return;
			
		int k;
		for (k = 0; temp[k] != '\0'; k++)
			date[k] = temp[k];
		date[k] = '\0';
	}
	catch(...)
	{
		std::cout << "\n\nAn unknown error has occurred." << std::endl;
	}
}
		


void SiteList::Edit()
{
	try
	{
		if (Iterate() == 0)
			return;
		std::cout << "\n\nEnter the number next to the name of the website you want to edit, or 0 to return " \
			"to the main menu: ";
		int siteNumber;
		std::cin >> siteNumber;
		std::cin.ignore(1, '\n');	
		if (siteNumber > itsList.size() || itsList.size() < 0)
			throw OutOfBounds(itsList.size());
		if (siteNumber == 0)
			return;
			
		// find the requested website and call its Edit() method
		int i = 1;
		std::list<Website>::iterator ci; // needs longer lifetime than 'for' statement
		for (ci = itsList.begin(); i < siteNumber; ci++, i++)
			;
		ci->EditData(*this);
	}
	catch(OutOfBounds &ErrorType)
	{
		ErrorType.PrintError();
		Edit();
	}
	catch(...)
	{
		std::cout << "\n\nAn unknown error has occurred." << std::endl;
	}
}



void SiteList::Input()
{
	try
	{
		Website newSite;
		char *buffer = new char[1001];	// getline() can only take a char*
		char flag = 'y';
		while (flag == 'Y' || flag == 'y')
		{
			std::cout << "Enter the name: ";
			std::cin.getline(buffer, 101);
			if (buffer[0] != '\0')
			{
				if (NameExists(buffer))
					throw DuplicateName(buffer);
				newSite.SetName(buffer);
			}
			else
			{
				std::cout << "You must enter a name.\n";
				continue;
			}
		
			std::cout << "Enter the URL: ";
			std::cin.getline(buffer, 101);
			if (buffer[0] != '\0')
				newSite.SetURL(buffer);
			
			std::cout << "Enter the host: ";
			std::cin.getline(buffer, 101);
			if (buffer[0] != '\0')
				newSite.SetHost(buffer);
			
			std::cout << "Enter the date of creation: ";
			std::cin.getline(buffer, 50);
			if (buffer[0] != '\0')
			{
				ConvertDateFormat(buffer);
				newSite.SetDate(buffer);
			}
			
			std::cout << "Enter the name of the administrator/owner: ";
			std::cin.getline(buffer, 101);
			if (buffer[0] != '\0')			
				newSite.SetAdmin(buffer);
			
			std::cout << "Enter a description (up to 1000 characters): ";
			std::cin.getline(buffer, 1001);
			if (buffer[0] != '\0')
				newSite.SetDescription(buffer);
			
			itsList.push_back(newSite);
			
			do
			{
				std::cout << "Add another website? (Y)es/(N)o: ";
				std::cin.get(flag);
				
				if (flag != 'Y' && flag != 'y' && flag != 'N' && flag != 'n')
					std::cout << "Please enter the letter Y or N. " << std::endl;
				else
					break;
			} while (1);
			
			std::cin.ignore(1, '\n');
		}
	}
	catch(DuplicateName &ErrorType)
	{
		ErrorType.PrintError();
		Input();
	}
	catch(...)
	{
		std::cout << "\n\nAn unknown error has occurred." << std::endl;
	}
}



int SiteList::Iterate() const
{

	if (itsList.empty())
	{
		std::cout << "\n\nThere are no websites to display. " << std::endl;
		return 0;
	}

	std::cout << "\n\n";
	int i = 1;
	for (std::list<Website>::const_iterator ci = itsList.begin(); ci != itsList.end(); ci++, i++)
		std::cout << i << ": " << ci->GetName() << "\n";
	return itsList.size();
}



void SiteList::Load(char *file)
{	
	try
	{	
		std::cout << "\n\nLoading data..." << std::endl;
		
		std::ifstream fin(file);
		if (fin == 0)
			throw BadFileRead(file);
		std::list<Website> temp;
		Website newSite;
		std::string *Data[6];

		Data[0] = &newSite.itsName;
		Data[1] = &newSite.itsURL;
		Data[2] = &newSite.itsHost;
		Data[3] = &newSite.itsDate;
		Data[4] = &newSite.itsAdmin;
		Data[5] = &newSite.itsDescription;

		for (int i = 0; i < 6; i++)
			*Data[i] = "";

		char ch;
		int j = 0;
		while (fin.peek() != EOF)
		{
			while (j < 6)
			{	
				if (fin.peek() != '\t')
				{
					fin.get(ch);
					*Data[j] += ch;
				}
				else if (fin.peek() == '\t')
				{
					fin.ignore(1, '\n');
					j++;
				}
			}
			temp.push_back(newSite);
			
			for (int i = 0; i < 6; i++)
				*Data[i] = "";
			j = 0;
		}
		itsList = temp;
		
		fin.close();
	}
	catch(BadFileRead &ErrorType)
	{
		ErrorType.PrintError();
	}
	catch(...)
	{
		std::cout << "\n\nAn unknown error has occurred." << std::endl;
	}
}


bool SiteList::NameExists(char *name)
{
	for (std::list<Website>::const_iterator ci = itsList.begin(); ci != itsList.end(); ci++)
	{
		if (ci->GetName() == name)
			return true;
	}
	return false;
}



void SiteList::Remove()
{
	try
	{		
		if (Iterate() == 0)
			return;
		std::cout << "\n\nEnter the number next to the website you want to remove, or 0 to " \
			"return to the main menu: ";
		int siteNumber;
		std::cin >> siteNumber;
		if ( (siteNumber < 0) || (siteNumber > itsList.size()) )
			throw OutOfBounds(itsList.size());
		else if (siteNumber == 0)
			return;
		
		// remove the website by copying everything but it to a temporary std::list
		std::list<Website> temp;
		int i = 1;
		for (std::list<Website>::const_iterator ci = itsList.begin(); ci != itsList.end(); ci++, i++)
		{
			if (i != siteNumber)
				temp.push_back(*ci);
		}
		itsList = temp;
	}
	catch(OutOfBounds &ErrorType)
	{
		ErrorType.PrintError();
		Remove();
	}
	catch(...)
	{
		std::cout << "An unknown error has occurred." << std::endl;
	}
}


void SiteList::Save(char *file)
{
	try
	{
		std::cout << "\n\nSaving..." << std::endl;
		std::ofstream fout(file);
		if (fout == 0)
			throw BadFileRead(file);

		for (std::list<Website>::const_iterator ci = itsList.begin(); ci != itsList.end(); ci++)
		{
			fout << ci->GetName() << '\t';
			fout << ci->GetURL() << '\t';
			fout << ci->GetHost() << '\t';
			fout << ci->GetDate() << '\t';
			fout << ci->GetAdmin() << '\t';
			fout << ci->GetDescription() << '\t';		
		}
		
		fout.close();
	}
	catch(BadFileRead &ErrorType)
	{
		ErrorType.PrintError();
	}
	catch(...)
	{
		std::cout << "\n\nAn unknown error has occurred." << std::endl;
	}

}



void SiteList::Search()
{
	std::cout << "\nEnter the name of the website to search for, or Return/Enter to return to the main menu: ";
	
	char siteName[101];
	std::cin.getline(siteName, 101);
	
	if (siteName[0] == '\0')
		return;
	
	for (std::list<Website>::const_iterator ci = itsList.begin(); ci != itsList.end(); ci++)
	{
		if (ci->GetName() == siteName)
		{
			ci->Display();
			return;
		}
	}
	std::cout << "\nYour search query returned no results." << std::endl;
}



void SiteList::ShowList() const
{
	try
	{
		if (Iterate() == 0)
			return;
		std::cout << "\n" << itsList.size() << (itsList.size() == 1? " website": " websites") << ".\n\n";
		std::cout << "To display the information for a website, enter the number next to its name, "	\
			"or 0 to return to the main menu: ";
		int siteNumber;
		std::cin >> siteNumber;
		if (siteNumber > itsList.size() || itsList.size() < 0)
			throw OutOfBounds(itsList.size());
		if (siteNumber == 0)
			return;

		// find the requested website and call its Display() method
		int i = 1;
		std::list<Website>::const_iterator ci; // needs longer lifetime than 'for' statement
		for (ci = itsList.begin(); i < siteNumber; ci++, i++)
			;
		ci->Display();
	}
	catch(OutOfBounds &ErrorType)
	{
		ErrorType.PrintError();
		ShowList();
	}
	catch(...)
	{
		std::cout << "An unknown error has occurred." << std::endl;
	}		
}