#include "Website.h"
#include "SiteList.h"

Website::Website():	
	itsName("N/A"), 
	itsURL("N/A"), 
	itsHost("N/A"), 
	itsDate("N/A"), 
	itsAdmin("N/A"), 
	itsDescription("N/A")
{}



Website::Website(const Website &rhs):	
	itsName(rhs.GetName()), 
	itsURL(rhs.GetURL()), 
	itsHost(rhs.GetHost()), 
	itsDate(rhs.GetDate()), 
	itsAdmin(rhs.GetAdmin()), 
	itsDescription(rhs.GetDescription())
{}



void Website::Display() const
{
	try
	{
		std::cout << "\n\n----------------------------------------" << std::endl;
		std::cout << "Name:\t\t\t\t" << GetName() << std::endl;
		std::cout << "URL:\t\t\t\t" << GetURL() << std::endl;
		std::cout << "Host:\t\t\t\t" << GetHost() << std::endl;
		std::cout << "Date of Creation:\t\t" << GetDate() << std::endl;
		std::cout << "Administrator:\t\t\t" << GetAdmin() << std::endl;
		std::cout << "Description:\t\t\t" << GetDescription() << std::endl;
		std::cout << "----------------------------------------\n\n" << std::endl;
	}
	catch(...)
	{
		std::cout << "An unknown error has occurred." << std::endl;
	}
}



void Website::EditData(SiteList& theList)
{
	try
	{
		char *buffer = new char[1001];	// getline() can only take a char*
				
		std::cout << "Enter the name: ";
		std::cin.getline(buffer, 101);
		if (buffer[0] != '\0')
		{
			if (theList.NameExists(buffer))
				throw SiteList::DuplicateName(buffer);
			itsName = buffer;
		}

		std::cout << "Enter the URL: ";
		std::cin.getline(buffer, 101);
		if (buffer[0] != '\0')
			SetURL("buffer");
		
		std::cout << "Enter the host: ";
		std::cin.getline(buffer, 101);
		if (buffer[0] != '\0')		
			SetHost("buffer");
		
		std::cout << "Enter the date of creation: ";
		std::cin.getline(buffer, 50);
		if (buffer[0] != '\0')			
		{
				SiteList::ConvertDateFormat(buffer);
				SetDate("buffer");
		}
		
		std::cout << "Enter the name of the administrator/owner: ";
		std::cin.getline(buffer, 101);
		if (buffer[0] != '\0')		
			SetAdmin("buffer");
		
		std::cout << "Enter a description (up to 1000 characters): ";
		std::cin.getline(buffer, 1001);
		if (buffer[0] != '\0')		
			SetDescription("buffer");
	}
	catch(SiteList::DuplicateName &ErrorType)
	{
		ErrorType.PrintError();
		EditData(theList);
	}
	catch(...)
	{
		std::cout << "An unknown error has occured." << std::endl;
	}
}
