#include <iostream>
#include <fstream>
#include "SiteList.h"

int main(int argc, char *argv[])
{
	char *file;	
	if (argc > 1)
		file = argv[1];
	else if (argc == 1)
		file = "/Portfolio_data.txt";
	
	// if the file doesn't already exist, create it
	std::ifstream fin(file);
	if (!fin)
	{
		std::ofstream fout(file);
		fout.close();
	}
	fin.close();
	
	
	SiteList Portfolio;
	Portfolio.Load(file);
	
	bool loop = true;
	int choice;
	while (loop)
	{
		std::cout << "\n\n";
		std::cout << "1. Add entry" << std::endl;
		std::cout << "2. Edit entry" << std::endl;
		std::cout << "3. Remove entry" << std::endl;
		std::cout << "4. Show Portfolio" << std::endl;
		std::cout << "5. Search" << std::endl;
		std::cout << "6. Clear All" << std::endl;
		std::cout << "7. Quit" << std::endl;

		std::cout << "\nEnter your selection: ";
		std::cin >> choice;
		std::cin.ignore(1, '\n');
		
		switch (choice)
		{
			case 1:
				Portfolio.Input();
				break;
			case 2:
				Portfolio.Edit();
				break;
			case 3: 
				Portfolio.Remove();
				break;
			case 4:
				Portfolio.ShowList();
				break;
			case 5:
				Portfolio.Search();
				break;
			case 6:
				Portfolio.ClearAll();
				break;
			case 7:
				loop = false;
				break;
			default:
				std::cout << "Please enter a valid selection." << std::endl;
		}
	}
	
	Portfolio.Save(file);
	
    return 0;
}
